import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { getCacheData } from './utils/helper';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class ApproveTransactionService {
  constructor(private http: HttpClient) {}

  getSendCountry() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/send-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrency(SendCountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/send-currency?SendCountryID=${SendCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getStatus(AgentID: any, AgentSubGroupID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/status?AgentID=${AgentID}&AgentSubGroupID=${AgentSubGroupID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransferType(AgentID: any, GroupID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/transfer-type?AgentID=${AgentID}&GroupID=${GroupID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountry(SendCountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/receive-country?SendCountryID=${SendCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrency(ReceiveCountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/receive-currency?ReceiveCountryID=${ReceiveCountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgent(AgentID: any = 0, CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/agent?AgentID=${AgentID}&CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentBranch(AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/agent-branch?AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getUser(AgentID: any, AgentBranchID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction/approve-transaction/user?AgentID=${AgentID}&AgentBranchID=${AgentBranchID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
