import { Component } from '@angular/core';
import { BlockUnblockTransactionService } from '../block-unblock-transaction.service';

@Component({
  selector: 'app-block-unblock-transaction',
  templateUrl: './block-unblock-transaction.component.html',
  styleUrls: ['./block-unblock-transaction.component.css'],
})
export class BlockUnblockTransactionComponent {
  CountryDropdown: any;
  AgentDropdown: any;
  StatusDropDown: any;
  AgentBranchDropDown: any;
  DataList: any;
  AgentID: any = 0;
  AgentBranchID: any = 0;
  StatusId: any = -1;
  fromDate: any;
  toDate: any;
  constructor(
    private BlockUnblockTransactionSvc: BlockUnblockTransactionService
  ) {}

  ngOnInit(): void {
    this.getCountry();
  }
  getCountry() {
    this.BlockUnblockTransactionSvc.getCountry().subscribe((res) => {
      this.CountryDropdown = res;
    });
  }

  onSelectCountry(CountryID) {
    this.getAgent(CountryID);
    this.getStatus();
  }

  getAgent(CountryID) {
    this.BlockUnblockTransactionSvc.getAgent(CountryID).subscribe((res) => {
      this.AgentDropdown = res;
    });
  }

  OnSelectAgent(AgentID) {
    this.AgentID = AgentID;
    this.getAgentbranch(AgentID);
  }

  getAgentbranch(AgentID) {
    this.BlockUnblockTransactionSvc.getAgentBranch(AgentID).subscribe((res) => {
      this.AgentBranchDropDown = res;
    });
  }

  onSelectAgentbranch(AgentBranchID) {
    this.AgentBranchID = AgentBranchID;
  }

  getStatus() {
    this.BlockUnblockTransactionSvc.getStatus().subscribe((res) => {
      this.StatusDropDown = res;
    });
  }

  onSelectStatus(StatusId) {
    this.StatusId = StatusId;
  }

  getBranchName(agent_id) {
    for (var i = 0; i < this.AgentBranchDropDown?.length; i++) {
      if (this.AgentBranchDropDown[i].AgentBranch_ID == agent_id) {
        return this.AgentBranchDropDown[i].AgentBranch_Name;
      }
    }
    return 'All';
  }
  getData() {
    const AgentBranch = this.getBranchName(this.AgentBranchID);

    this.BlockUnblockTransactionSvc.getDataByDate(
      this.fromDate,
      this.toDate,
      this.AgentID,
      this.StatusId,
      AgentBranch,
      this.AgentBranchID
    ).subscribe((res) => {
      this.DataList = res;
    });
  }
}
