import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class DownloadTransactionsFileService {
  constructor(private http: HttpClient) {}

  getTransactionDownloadFileList(searchText: any = 0, searchType: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/transaction-management/transaction-download-file/all-record?searchText=${searchText}&SearchType=${searchType}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
