import { Component, OnInit } from '@angular/core';
import { BeneficiaryComplianceReleaseReportRejectService } from '../services/beneficiary-compliance-release-report-reject.service';
import { Router } from '@angular/router';

@Component({
  selector: 'app-release-beneficiary-compliance-reject',
  templateUrl: './release-beneficiary-compliance-reject.component.html',
  styleUrls: ['./release-beneficiary-compliance-reject.component.css'],
})
export class ReleaseBeneficiaryComplianceRejectComponent {
  beneficiaryDetails: any[] = [];
  beneficiaryNumber: string = '';

  constructor(
    private releaseService: BeneficiaryComplianceReleaseReportRejectService,
    private router: Router
  ) {}
  navigateToBeneficiary(beneficiaryNumber: any) {
    this.router.navigate([
      `/panel/beneficiary-compliance-release-report/${beneficiaryNumber}`,
    ]);
  }
  ngOnInit() {
    this.getStatusRecords();
  }
  onBeneficiaryNumberChange(value: string) {
    this.beneficiaryNumber = value;
  }
  searchBeneficiary() {
    console.log('Beneficiary Number:', this.beneficiaryNumber);
    if (this.beneficiaryNumber.trim() !== '') {
      this.releaseService.getAllRecords(this.beneficiaryNumber).subscribe(
        (response: any) => {
          this.beneficiaryDetails = response;
        },
        (error) => {
          console.error('Error fetching beneficiary details:', error);
          this.beneficiaryDetails = null;
        }
      );
    } else {
      console.log('Please enter a beneficiary number');
      this.beneficiaryDetails = null;
    }
  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
  getStatusRecords() {
    this.releaseService.getStatusRecords('Reject').subscribe(
      (response: any[]) => {
        this.beneficiaryDetails = response;
      },
      (error) => {
        console.error('Error fetching beneficiary details:', error);
      }
    );
  }

  getOfacLogDetails(transactionNumber: string) {
    this.releaseService.complicanceOfacLogDetails(transactionNumber).subscribe(
      (response: any) => {
        console.log('OFAC Log Details:', response);
      },
      (error) => {
        console.error('Error fetching OFAC Log Details:', error);
      }
    );
  }
}
