import { Component } from '@angular/core';
import { SendAgentsCtaTransactionsService } from '../send-agents-cta-transactions.service';
import { DatePipe } from '@angular/common';
@Component({
  selector: 'app-send-agents-cta-transactions',
  templateUrl: './send-agents-cta-transactions.component.html',
  styleUrls: ['./send-agents-cta-transactions.component.css'],
})
export class SendAgentsCtaTransactionsComponent {
  constructor(
    private SendAgentsCtaTransactionsSvc: SendAgentsCtaTransactionsService,
    private datePipe: DatePipe
  ) {}

  AgentID: any;
  CountryList: any;
  toDate: any = Date.now();
  AgentList: any;
  allData: any;

  ngOnInit(): void {
    this.getCountry();
    this.getAgent();
  }

  onSelectDate() {
    this.getCountry();
    this.getAgent();
  }

  getCountry() {
    const date = this.datePipe.transform(this.toDate, 'yyyy-MM-dd');
    this.SendAgentsCtaTransactionsSvc.getCountry(date).subscribe((res) => {
      this.CountryList = res;
    });
  }

  getAgent() {
    const date = this.datePipe.transform(this.toDate, 'yyyy-MM-dd');
    this.SendAgentsCtaTransactionsSvc.getAgent(date).subscribe((res) => {
      this.AgentList = res;
      this.AgentID = res[0].Agent_ID;
    });
  }

  onSelectAgent(AgentID) {
    this.AgentID = AgentID;
  }

  allRecord() {
    const date = this.datePipe.transform(this.toDate, 'yyyy-MM-dd');
    this.SendAgentsCtaTransactionsSvc.getAllRecord(
      date,
      this.AgentID
    ).subscribe((res) => {
      this.allData = res;
    });
  }
}
