import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ComplianceUploadReportService {
  url = environment.apiUrl;
  constructor(private http: HttpClient) {}

  getAllComplianceUploadReportRecords() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/compliance-upload-report/all-record`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
