import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class ManageModeOfPaymentService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getAllManageModeofPayment(
    token: any,
    username,
    countryId = 0
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country-wise-mode-of-payment?countryId=${countryId}`,
      {
        headers: headers,
      }
    );
  }

  addModeofPayment(token: any, username: any, payload: any): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/country-wise-mode-of-payment
      `,
      payload,
      {
        headers: headers,
      }
    );
  }

  updateModeofPayment(
    token: any,
    username: any,
    payload: any
  ): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.patch(
      `${environment.apiUrl}/v1/api/master/country-wise-mode-of-payment`,
      payload,
      {
        headers: headers,
      }
    );
  }

  getModeofPayments(token: any, username): Observable<any> {
    const headers = new HttpHeaders({
      Authorization: token,
      Accept: 'application/json',
      username: username,
    });
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/country/mode-of-payment-list`,
      {
        headers: headers,
      }
    );
  }
}
