import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class MapTrMasterService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getPayoutXmlList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/map-tr-master/payout-xml-tag-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCountryList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/map-tr-master/country-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
