import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SendingAgentMarginService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSendCountryList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/send-country`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList(sendCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/send-agent?SendCountryID=${sendCountryId}&SessionG_Agent_ID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(sendCountryId: any = 0, sendAgentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/fill-grid?SendCountryID=${sendCountryId}&SendAgentID=${sendAgentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCountryAddList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/add/send-country?AsPerPermission=true&permissionType=2`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentAddList(sendCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/add/send-agent?CountryID=${sendCountryId}&permission=2`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentCurrency(sendCountryId: any = 0, sendAgentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/add/agent-currency?AgentID=${sendAgentId}&CountryID=${sendCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountry(sendCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/add/receive-country?PayInCountryId=${sendCountryId}&permission=1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrency(sendCountryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/sa-margin/add/receive-currency?CountryID=${sendCountryId}&AgentID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
