import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SendingPercentageWiseService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSendCountryList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-min-max-commission/send-country-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentList(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-min-max-commission/send-agent-list?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(countryId: any = 0, agentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-min-max-commission/all-record?CountryID=${countryId}&AgentID=${agentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryList(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-min-max-commission/receive-country-list?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCurrencyList(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/mastertransaction/edit-transaction/payout-currency-List?countryId=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentAccountList(countryId: any = 0, currencyId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-rate/insert-record/agent-account-list?countryId=${countryId}&currencyId=${currencyId}
     `,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getModeofPaymentList(countryId: any = 0, receiveAgentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-min-max-commission/mode-of-payment-list?CountryID=${countryId}&ReceAgentID=${receiveAgentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendAgentInsertList(currencyId: any = 0, countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/agent-wise-commission/receiveagent-insert?CurrencyID=${currencyId}&CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  addSendingPercentageWise(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/agent-min-max-commission/insert`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
