import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SuspiciousTransactionReportService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getFillGrid(fromDate: any, toDate: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/compliance-management/compliance-reports/suspicious-transaction-report?FromDate=${fromDate}&ToDate=${toDate}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDataByTransactionNo(transactionNo: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/compliance-management/compliance-reports/suspicious-transaction-report?SRTRNo=${transactionNo}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
