import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ViewComplainceHoldListService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  fetchComplianceHoldListRecords(
    topRecords: any = '',
    transactionNumber: any = '',
    name: any = ''
  ) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/all-record?TopRecords=${topRecords}&TransactionNumber=${transactionNumber}&Name=${name}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  filterdByRecords(transactionNumber: any = '') {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/all-record?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewComplianceHoldList(transactionNumber: any = '') {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/view-complaice?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewComplianceHoldListLog(transactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/log?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  viewComplianceHoldListView(transactionNumber: any, showOFAC: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/view?TransactionNumber=${transactionNumber}&showOFAC=${showOFAC}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  viewComplianceHoldListCustomerDetail(transactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/customer-show-detail?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewComplianceHoldListBeneficiaryDetail(transactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/beneficiary-show-detail?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  viewComplianceHoldListPrintDetail(transactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/print-detail?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  viewComplianceHoldListCustomerApprove(requestPayload: any) {
    return this.http.post(
      ` ${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/customer-approve`,
      requestPayload,
      {
        headers: {
          'Content-Type': 'application/json',
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewComplianceHoldListCustomerReject(requestPayload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/customer-reject`,
      { viewComplainceHoldListCustomerRejectRequest: requestPayload },
      {
        headers: {
          'Content-Type': 'application/json',
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  
  viewComplianceHoldListBeneficiaryApprove(requestPayload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/beneficiary-approve`,
      { viewComplainceHoldListCustomerBeneficiaryRequest: requestPayload },
      {
        headers: {
          'Content-Type': 'application/json',
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewComplianceHoldListBeneficiaryReject(requestPayload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/beneficiary-reject`,
      { viewComplainceHoldListCustomerRejectRequest: requestPayload },
      {
        headers: {
          'Content-Type': 'application/json',
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  viewComplianceHoldListReject(requestPayload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/reject`,
      { viewComplainceHoldListRequest: requestPayload },
      {
        headers: {
          'Content-Type': 'application/json',
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  viewComplianceHoldListRelease(requestPayload: any) {
    return this.http.post(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/release`,
      { viewComplainceHoldListApprove: requestPayload },
      {
        headers: {
          'Content-Type': 'application/json',
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  
  viewComplianceHoldListDetails(transactionNumber: any, showOFAC: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/complicance/view-complaince-hold-list/view`,
      {
        params: {
          TransactionNumber: transactionNumber,
          showOFAC: showOFAC,
        },
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  
  
}

