import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ViewTransactionStatusService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSendCountryList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/payin-country-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDestCountry() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/transection-country-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDestCurrency(agentId) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/payout-currency-list?countryId=${agentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentUser(AgentBranchID: any, AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/agent-user-list?AgentBranchID=${AgentBranchID}&AgentID=${AgentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(payload: any = '') {
    return this.http.post(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/get-data`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentTypeList() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/agent-type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSendCurrencyList(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/payin-currency-list?countryId=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransferTypeList(_Agent_ID: any, _Group: any) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/transfer-type-list?_Agent_ID=${_Agent_ID}&_Group=${_Group}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransactionStatus() {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/transection-status`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList(_TargetCountryID, _Agent_ID: any = 0, _Type: any = 2) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/agent-list?_TargetCountryID=${_TargetCountryID}&_Agent_ID=${_Agent_ID}&_Type=${_Type}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentBranchList(agentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/v1/api/master/transection-managment/view-transection-status/agent-branch-list?agentID=${agentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

}
