import { Component } from '@angular/core';
import { StopPaymentService } from '../services/stop-payment.service';

@Component({
  selector: 'app-stop-payment',
  templateUrl: './stop-payment.component.html',
  styleUrls: ['./stop-payment.component.css'],
})
export class StopPaymentComponent {
  status: any = [];
  selectedStatus: any;
  allStatus: any = [];
  selectedAllStatus: any;
  agentTypes: any = [];
  selectedAgentType: any;
  searchByType: any = 1;
  viewLast: any;
  AllData: any;
  typeList: any = [
    {
      id: 1,
      name: 'Send',
    },
  ];
  selecteStatus: any;
  selectedType: any = 1;
  sendCountryList: any = [];
  selectedSendCountryList: any = 'All';
  destCountryList: any = [];
  selectedDestCountryList: any = 'All';
  sendCurrencyList: any = [];
  selectedSendCurrencyList: any = 'All';
  destCurrencyList: any = [];
  selectedDestCurrencyList: any = 'All';
  agentList: any = [];
  selectedAgentList: any = 'All';
  userList: any = [];
  selectedUserList: any = 'All';
  agentBranchList: any = [];
  selectedAgentBranchList: any = 'All';
  transferTypeList: any = [];
  selectedTransferTypeList: any = 'All';

  startDate: any;
  endDate: any;
  transactionNo: any;
  customerNameFirst: any;
  customerNameLast: any;
  beneficiaryNameFirst: any;
  beneficiaryNameLast: any;

  constructor(private stopPaymentSvc: StopPaymentService) {}

  ngOnInit(): void {
    this.getStatusList();
    this.getAllStatusList();
    this.getAgentTypeList();
    this.getSendCountryList();
    this.getDestinationCountryList();
    this.getTransferTypeList();
  }

  getStatusList() {
    this.stopPaymentSvc.getStatusList().subscribe({
      next: (res: any) => {
        this.status = res;
        this.selectedStatus = res?.[0]?.TrStatusID;
      },
      error: () => {
        this.status = [];
      },
      complete: () => {},
    });
  }

  getAllStatusList() {
    this.stopPaymentSvc.getAllStatusList().subscribe({
      next: (res: any) => {
        this.allStatus = res;
        this.selectedAllStatus = res?.[0]?.TrStatusID;
      },
      error: () => {
        this.allStatus = [];
      },
      complete: () => {},
    });
  }

  getAgentTypeList() {
    this.stopPaymentSvc.getAgentTypeList().subscribe({
      next: (res: any) => {
        this.agentTypes = res;
        this.selectedAgentType = res?.[0]?.Group_Id;
      },
      error: () => {
        this.agentTypes = [];
      },
      complete: () => {},
    });
  }

  getSendCountryList() {
    this.stopPaymentSvc.getSendCountryList().subscribe({
      next: (res: any) => {
        this.sendCountryList = res;
      },
      error: () => {
        this.sendCountryList = [];
      },
      complete: () => {},
    });
  }

  onSendCountryChange(countryId: any) {
    if (countryId != 'All') {
      this.getSendCurrencyList(countryId);
      this.getAgentList(countryId);
    }
  }

  getDestinationCountryList() {
    this.stopPaymentSvc.getDestinationCountryList().subscribe({
      next: (res: any) => {
        this.destCountryList = res;
      },
      error: () => {
        this.destCountryList = [];
      },
      complete: () => {},
    });
  }

  onDestinationCountryChange(countryId: any) {
    if (countryId != 'All') {
      this.getDestinationCurrencyList(countryId);
    }
  }

  getSendCurrencyList(countryId: any = 0) {
    this.stopPaymentSvc.getSendCurrencyList(countryId).subscribe({
      next: (res: any) => {
        this.sendCurrencyList = res;
      },
      error: () => {
        this.sendCurrencyList = [];
      },
      complete: () => {},
    });
  }

  getDestinationCurrencyList(countryId: any = 0) {
    this.stopPaymentSvc.getDestinationCurrencyList(countryId).subscribe({
      next: (res: any) => {
        this.destCurrencyList = res;
      },
      error: () => {
        this.destCurrencyList = [];
      },
      complete: () => {},
    });
  }

  getAgentList(targetCountryId: any = 0) {
    this.stopPaymentSvc.getAgentList(targetCountryId).subscribe({
      next: (res: any) => {
        this.agentList = res;
      },
      error: () => {
        this.agentList = [];
      },
      complete: () => {},
    });
  }

  onAgentChange(agentId: any) {
    if (agentId != 'All') {
      this.getAgentBranchList(agentId);
    }
  }

  getUserList(agentId: any = 0, agentBranchId: any = 0) {
    this.stopPaymentSvc.getUserList(agentId, agentBranchId).subscribe({
      next: (res: any) => {
        this.userList = res;
      },
      error: () => {
        this.userList = [];
      },
      complete: () => {},
    });
  }

  getAgentBranchList(agentId: any = 0) {
    this.stopPaymentSvc.getAgentBranchList(agentId).subscribe({
      next: (res: any) => {
        this.agentBranchList = res;
      },
      error: () => {
        this.agentBranchList = [];
      },
      complete: () => {},
    });
  }

  onAgentBranchChange(agentBranchId: any) {
    if (agentBranchId != 'All' && this.selectedAgentList != 'All') {
      this.userList(this.selectedAgentList, agentBranchId);
    }
  }

  getTransferTypeList() {
    this.stopPaymentSvc.getTransferTypeList().subscribe({
      next: (res: any) => {
        this.transferTypeList = res;
      },
      error: () => {
        this.transferTypeList = [];
      },
      complete: () => {},
    });
  }

  onSearchByChange(event) {
    this.searchByType = Number(event.target.value);
  }

  onSelectViewLast(event) {
    this.viewLast = event;
  }

  onSelectStatus(event) {
    this.selecteStatus = event;
  }
  getAllData() {
    let payload: any = {};
    if (this.searchByType == 1) {
      payload = {
        SearchByType: this.searchByType,
        TopRecord: 0,
        Agent_ID: 0,
        PayOutCountry: -1,
        PayOutCurrency: -1,
        SubType: -1,
        SessionAgent_ID: 0,
        SRTRNo: this.transactionNo,
        TrStatusID: -1,
        TrTypeID: -1,
        PayInCountry: -1,
        PayInCurrency: -1,
        LoginCountryID: 0,
        UserID: -1,
        AgentBranchId: -1,
      };
    }
    if (this.searchByType === 2) {
      payload = {
        SearchByType: this.searchByType,
        TopRecord: this.viewLast,
        Agent_ID: 0,
        PayOutCountry: -1,
        PayOutCurrency: -1,
        SubType: -1,
        TrStatusID: this.selecteStatus,
        TrStatusList: this.status,
        TrTypeID: -1,
        PayInCountry: -1,
        PayInCurrency: -1,
        UserID: '-1',
        AgentBranchId: -1,
      };
    }
    if (this.searchByType === 3) {
      payload = {
        SearchByType: this.searchByType,
        TopRecord: this.viewLast,
        Agent_ID: 0,
        PayOutCountry: -1,
        PayOutCurrency: -1,
        SubType: -1,
        SRTRNo: this.transactionNo,
        TrStatusID: this.selecteStatus,
        TrStatusList: this.status,
        TrTypeID: -1,
        StartDate: this.startDate,
        EndDate: this.endDate,
        PayInCountry: -1,
        PayInCurrency: -1,
        UserID: '-1',
        AgentBranchId: -1,
        Beneficiary_Name_F: this.beneficiaryNameFirst
          ? this.beneficiaryNameFirst
          : '',
        Beneficiary_Name_L: this.beneficiaryNameLast
          ? this.beneficiaryNameLast
          : '',
        Customer_Name_F: this.customerNameFirst ? this.customerNameFirst : '',
        Customer_Name_L: this.customerNameLast ? this.customerNameLast : '',
      };
    }

    this.stopPaymentSvc.getAllData(payload).subscribe({
      next: (res: any) => {
        this.AllData = res;
      },
      error: () => {
        this.transferTypeList = [];
      },
      complete: () => {},
    });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
